#!/usr/bin/python
#-*- coding: utf-8 -*-
#/******************************************************************************
#*                       Pyfocus                                    *
#*******************************************************************************
#*                                                                             *
#*           Copyright (C) 2007  JB BUTET                               *
#*                                                                             *
#*                                                                             *
#*  This program is free software; you can redistribute it and/or modify       *
#*  it under the terms of the GNU General Public License as published by       *
#*  the Free Software Foundation; either version 2 of the License, or          *
#*  (at your option) any later version.                                        *
#*                                                                             *
#*  This program is distributed in the hope that it will be useful,            *
#*  but WITHOUT ANY WARRANTY; without even the implied warranty of             *
#*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
#*  GNU General Public License for more details.                               *
#*                                                                             *
#*  You should have received a copy of the GNU General Public License          *
#*  along with this program; if not, write to the Free Software                *
#*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA  *
#*                                                                             *
#*                                                                             *
#*                                                                             *
#*  For further information contact me at ashashiwa@gmail.com             *
#******************************************************************************/



import sys, os, thread, time, commands, numpy
from PyQt4 import QtCore, QtGui
from math import sqrt 
from scipy import optimize
from Ui_pyfocus  import Ui_pyfocus_MainWindow
from Ui_zoom_dialog import Ui_Dialog_zoom

class camera(QtCore.QObject):
    """thid object is a camera"""
    def __init__(self,):
        QtCore.QObject.__init__(self)
        self.name = "No Camera "
        self.IsConnected = False
        self.isAutomated=False
        self.connection = "any ports"
        self.HasPicture = False
        self.detect_camera()
        
        #detect camera every delay seconds
        delay=5
        thread.start_new_thread(self.detect_camera_thread,(delay,))


    def time_shutter_get_list(self):
        """detect shutterspee available"""
        status, output=commands.getstatusoutput('gphoto2 --get-config shutterspeed')
        output=output.splitlines()
        self.shutter_speed_list={}
        if len(output)<20:
            self.isAutomated=False
        
        else : 
            for e in output :
                if "Choice" in e:
                    if "second" in e:
                        if eval(e.split()[2])!=0 :
                            self.shutter_speed_list[e.split()[1]]=e.split()[2]
            self.isAutomated=True
               
        
        #self.shutter_speed_list={ 1: 30,  2: 25  ,  3: 20  ,  4: 15  ,  5 :13  ,  6 :10  ,  7: 8  ,  8: 6  ,  9 :5  ,  10 :4  ,  11 :3.2  ,  12 :2.5  ,  13 :2  ,  14: 1.6  ,  15 :1.3  ,  16 :1  }
    
    def detect_camera_thread(self,delay):
        """detect if camera is connected and fill camera informations"""
        while 1:
            time.sleep(delay)
            self.detect_camera()
            
    def detect_camera(self) :
        #print "detect_camera"
        status,self.list_camera=commands.getstatusoutput('gphoto2 --auto-detect') #give list of supported cameras plugged
        self.list_camera=self.list_camera.split()
        #print self.list_camera
        if (len(self.list_camera) > 3) :
            
            
            self.connection = self.list_camera[-1][:-1]
            self.time_shutter_get_list()
            self.name = ' '.join(self.list_camera[3:-1])
            
            time.sleep(1)
            self.IsConnected=True

            
        else:
            
            self.name = self.tr("No Camera ")
            self.connection = self.tr("any ports")
            self.IsConnected=False


    def WhichLastPicture(self):
        """select last picture took and load it in self.lasPicture"""
        if self.IsConnected==False :
            pass
            #avert = avertissement(title = "ERREUR !" , principale = None)
        else :
            #list all camera files
            output,liste_photo=commands.getstatusoutput('gphoto2 -L') 
            AllFileList=liste_photo.splitlines() #coupe_sortie est la liste de toute la sortie standard
            #print "Camera File list", AllFileList
            #print output, liste_photo
            nbphoto=[]
            #print AllFileList
            for e in AllFileList: #e is a line
                try :
                    nb = e.split()[0]  # #97
                    e.split()[0].rindex('#') 
                    if "JPG" in e.split()[1] or "JPEG" in e.split()[1] or "jpg" in e.split()[1] or "jpeg" in e.split()[1] :
                        nbphoto.append(nb) 
                        nbphoto.append(e.split()[1]) #ajoute le nom de la photo
                except :
                    pass
            #print nbphoto
            LastPictureNumber=nbphoto[-2] #last Picture number. ex #97
            
            #print "numero derniere photo", numeroDernierePhoto
        
            LastPictureNumber=LastPictureNumber.replace("#"," ")
            self.LastPictureNumber=LastPictureNumber.strip()#recupere le numero propre. ex : '97'
        
            self.LastPictureName=nbphoto[-1]
            self.HasPicture = True
           
            #print self.tr("Last Picture"), str(self.LastPictureName),self.tr("is numbered "), self.LastPictureNumber #Ex: IMG_6769.JPG
 
    def UploadLastPicture(self,dir):
        """Upload Last Image in a file"""
        #print dir
        os.chdir(dir)
        UploadLastPictureCommand=str("gphoto2 -p " + str(self.LastPictureNumber))
        #print "Upload command ", UploadLastPictureCommand
        
        status,recupPhoto=commands.getstatusoutput(UploadLastPictureCommand)
        self.LastPictureName = recupPhoto.split()[-1]
        
        
class StartQT4(QtGui.QMainWindow):
    def __init__(self, parent=None,):
        QtGui.QMainWindow.__init__(self)
        #some ugly things
        self.IDRegion = 0
        self.dic={}
        self.camera_name_latest = self.tr("No Camera ")
        
        #####intialize directory
        pyfocusdir_install= os.path.dirname(__file__)
        home = os.getenv("HOME")
        os.chdir(home)
        pyfocusdir=home+"/.pyfocus"
        
        if os.path.exists(pyfocusdir):
            pass #print self.tr("directory ~/.pyfocus exists")
        else:
            #print self.tr("directory ~/.pyfocus has to be created")
            os.mkdir(pyfocusdir)
            os.mkdir(pyfocusdir+ "/images")
            os.mkdir(pyfocusdir+ "/icons")
            os.mkdir(pyfocusdir+ "/picture")
            #os.mkdir(pyfocusdir+ "/focus_thumbs")
            copy_commands='cp -R '+pyfocusdir_install+'/* '+pyfocusdir+"/"
            
            #print copy_commands
            status,output=commands.getstatusoutput(copy_commands)
            #print self.tr("directory ~/.pyfocus created and picture copied")
        os.chdir(pyfocusdir)
        self.pyfocusdir = pyfocusdir
        
        
        ######QT
        QtGui.QWidget.__init__(self, parent)
        self.ui = Ui_pyfocus_MainWindow()
        self.ui.setupUi(self)
        self.ui.label_image.setPixmap(QtGui.QPixmap("./images/fond.jpg"))
        self.ui.actionDownload_last_picture.setIcon(QtGui.QIcon("./icons/capture.png"))
        #self.ui.actionCapture_Picture.setIcon(QtGui.QIcon("./icons/download.png"))
        QtCore.QObject.connect(self.ui.actionDownload_last_picture,QtCore.SIGNAL("activated()"), self.download_picture)
        QtCore.QObject.connect(self.ui.actionCapture_Picture,QtCore.SIGNAL("activated()"), self.stop_thread1)
        #QtCore.QObject.connect(self.ui.label_image,QtCore.SIGNAL("clicked()"), self.picture_zoom)
        self.camera = camera()
        #print "objet appareil photo initialisé"
        self.dialog = StartQTdialog4(self,self.camera)
        #self.dialog.show()
        self.dialog.pyfocusdir = self.pyfocusdir

        #self.dialog.exec_() #to be removed
        
        self.Update_Label_informations(self.camera.name+self.tr(" connected on ") +self.camera.connection)
        
        
        #Update Camera information every delay_info seconds
        delay_infos=3
        thread.start_new_thread(self.UpdateLabelCameraInformations,(delay_infos,))
        
        #dic is needed to keep some interesting things
    def stop_thread1(self):
        #self.camera.thread1.shutdown()
        pass
    
    def Update_Label_informations(self, text):
        """allow multiple messages on label"""
        
        self.ui.label_information_camera.setText(QtCore.QString(text))
    
    def mouseReleaseEvent(self, event):
        """draw a rectangle near click and zoom it"""
        if self.camera.HasPicture == True : 
            dic={}
            self.dic_region = {}
            #print self.tr("mouse clicked on "), event.x(), event.y()
            y_ = event.y()-57
            x_ = event.x()+5
            #height issue
            x1,y1,x2,y2 =x_-30, y_-30, x_+30, y_+30
            dic['ActualSelection'] = (x1,y1,x2,y2)
            if x1 <0 or x2 <0 or y1 <0 or y2 <0 :
                #print self.tr("bad selection. near extrems")
                self.Update_Label_informations(self.tr("Please, choose another star"))
                
                
            else : 
                #image=Image.open(self.camera.LastPictureName)
                image=QtGui.QImage(self.camera.LastPictureName)
                x,y=image.size().width(), image.size().height()
                #print self.tr("Original Picture is "),str(x), " x "+ str(y)
            
                #X,Y=int((x*600.0)/y),600.0 #redimensionne l'image en 800/600
                #print str(X) + " " + str(Y)
                #self.image_resize=self.image.resize((X,Y),Image.BICUBIC)
                coeff_y=y/600.0
                coeff_x=x/800.0
                #print dic['ActualSelection'], coeff_x, coeff_y
                #rect = (int(x1*coeff_x), int(y1*coeff_y), int(x2*coeff_x)-29, int(y2*coeff_y))
                #print "real selection: ", int(x1*coeff_x), int(y1*coeff_y), int(x2*coeff_x), int(y2*coeff_y)
                rect = QtCore.QRect(int(x1*coeff_x), int(y1*coeff_y), int(int(x2*coeff_x)-int(x1*coeff_x))-29, int(int(y2*coeff_x)-int(y1*coeff_x)))
                self.dialog.rect = rect #need for next captures
                IDRegion = 1
                region = image.copy(rect)
                
                self.star = star(IDRegion, region)
                
                #print "square", region.size
                #self.dic_region[IDRegion] = region
                self.update_dialog_focus(self.star)
                
                
        else : 
            #print self.tr("No picture loaded")
            self.Update_Label_informations(self.tr("No Picture loaded"))
            pass

    def update_dialog_focus(self, star):
        """upadte focus dialog with last region"""
        self.dialog.star = star
        #self.dialog.expose_Capture("reference", None, None)
        #self.dialog.expose_Capture("last", None, None)
        
        self.dialog.expose_Capture("actual", star.image, star.number)
        
        self.dialog.exec_()
        
    def UpdateLabelCameraInformations(self, delay):
        """update delay with cameras informations"""
        
        while 1:
            #print "UpdateLabelCameraInformations"
            time.sleep(delay)
            self.Update_Label_informations(self.camera.name+self.tr(" connected on ") +self.camera.connection)
            #print self.camera_name_latest, self.camera.name
            if self.camera.isAutomated==True:
                if self.camera.name != self.camera_name_latest:#allow multiple camera to be plugged. combox in dialog is changed dynamically
                    for index, shutterspeed in self.camera.shutter_speed_list.items():
                        #print "index, shutterspeed", index, shutterspeed
                        self.dialog.ui.combo_shutter_speed_list.insertItem(int(index),str(shutterspeed)+self.tr(" seconds"))
                    self.camera_name_latest = self.camera.name
                self.dialog.ui.Button_NewCapture.setEnabled(1)
                self.dialog.ui.combo_shutter_speed_list.setEnabled(1)
                self.dialog.ui.label_infos.setEnabled(1)
            else :
                self.dialog.ui.Button_NewCapture.setEnabled(0)
                self.dialog.ui.combo_shutter_speed_list.setEnabled(0)
                self.dialog.ui.label_infos.setEnabled(0)


    def download_picture(self):
        """download last taken picture from camera, expose it and give a zoom if defined"""
        if self.camera.IsConnected==False :
            #print self.tr("No Camera detected : can't Upload")
            self.Update_Label_informations(self.tr("No Camera detected"))
            #self.avert("Please, plug the camera please")
        else : 
            #test la presence de la derniere photo
            self.camera.WhichLastPicture()
            
            chemin =self.pyfocusdir+"/picture/"+self.camera.LastPictureName
            #print chemin
            if os.path.isfile(chemin)==True :
                #print self.tr("File is already here")
                self.ExposedImage(self.camera.LastPictureName)
                
            else:
                #print self.tr("File isn't here... Dowloading it")
                self.camera.UploadLastPicture(self.pyfocusdir+"/picture")
                
                self.ExposedImage(self.camera.LastPictureName)

    def ExposedImage(self,picture):
        """expose Image given in argument on label_image widget and calcul picture informations"""
        os.chdir(self.pyfocusdir+"/picture")
        self.ui.label_image.setPixmap(QtGui.QPixmap(picture))
        #self.ImageInformation(picture)
        


    


        
    




class star(object):
    """this object is a star, select by pyfocus and displayed by dialog"""
    def __init__(self, IDRegion, region):
        self.name = ""
        self.number = IDRegion
        self.fwhm = 0
        self.image = region
        #imagedata=self.image.getdata()
        
        #tabimage = numpy.array(imagedata)
        #print tabimage

    

class StartQTdialog4(QtGui.QDialog):
    def __init__(self, parent,camera, ):
        QtGui.QDialog.__init__(self)
        self.star=None
        self.dic = {}
        self.parent=parent
        QtGui.QWidget.__init__(self, parent)
        self.ui = Ui_Dialog_zoom()
        self.ui.setupUi(self)
        self.camera=camera
        self.ui.Button_NewCapture.setEnabled(0)
        self.ui.combo_shutter_speed_list.setEnabled(0)
        self.ui.label_infos.setEnabled(0)
        QtCore.QObject.connect(self.ui.Button_make_reference,QtCore.SIGNAL("clicked()"),self.make_reference)
        QtCore.QObject.connect(self.ui.Button_make_reference_2,QtCore.SIGNAL("clicked()"),self.make_reference_from_list)
        #self.dialog.label_actual_pic.setPixmap(QtGui.QPixmap.fromImage(ImageQt.ImageQt(region)))
        QtCore.QObject.connect(self.ui.Button_NewCapture,QtCore.SIGNAL("clicked()"),self.take_capture)
        
        QtCore.QObject.connect(self.ui.Button_Manual_Capture,QtCore.SIGNAL("clicked()"),self.update_manual_capture)
        
        QtCore.QObject.connect(self.ui.doubleSpinBox,QtCore.SIGNAL("valueChanged(double)"),self.choose_last_picture)
        self.ui.doubleSpinBox.setMinimum(1)
   
    def update_manual_capture(self):
        """update all Labels with last taken picture"""
        if self.camera.IsConnected==False: 
            self.ui.label_manual_capture.setText("camera not connected")
        else : 
            self.ui.label_manual_capture.setText("Downloading picture")
            self.update_new_taken_picture()
            self.ui.label_manual_capture.setText("Picture updated")
            
    def choose_last_picture(self, event):
        #print self.dic
        #print "key", int(self.ui.doubleSpinBox.value())
        image=self.dic[int(self.ui.doubleSpinBox.value())]
        self.expose_Capture("last", image, self.ui.doubleSpinBox.value())
        
        
    def take_capture(self):
        """verify camera existence then send a capture order"""
        if self.camera.IsConnected==False:
            #print self.tr("please plug a camera")
            self.ui.label_infos.setText(self.tr("power On Camera"))
        
        elif  self.ui.combo_shutter_speed_list.currentText()==self.tr("Not defined"):
            self.ui.label_infos.setText(self.tr("Choose an exposure"))
        
        else :

            index = self.ui.combo_shutter_speed_list.currentIndex()
            #print "index", index
            status , output = commands.getstatusoutput(' gphoto2 -F 1  --set-config shutterspeed='+  str(index)) #this is to deblock camera... Gphoto bug
            time.sleep(1)
            status , output = commands.getstatusoutput(' gphoto2 -F 1  --set-config shutterspeed='+  str(index)+ ' --capture-image')
            #print self.ui.label_reference_pic.text()
            #print self.tr("wait for "), self.ui.combo_shutter_speed_list.currentText()
            waittime = str(self.ui.combo_shutter_speed_list.currentText()).split()[0]
            #print int(float(waittime))
            time.sleep(int(float(waittime)+3)) # 3 seconds to take care of process
            #print "self.star.number=", self.star.number
            
            self.update_new_taken_picture()
    
    def update_new_taken_picture(self):
        if self.ui.label_reference_pic.text()==self.tr("No Reference"):
            self.make_reference()
            self.dic[self.star.number]=self.star.image
            self.star.number+=1
            self.do_New_Star_Picture()
            self.expose_Capture("actual", self.star.image, self.star.number)
            self.parent.ExposedImage(self.camera.LastPictureName)

        
        
        else : 
            self.dic[self.star.number]=self.star.image
            self.star.number+=1
            self.do_New_Star_Picture()
            self.expose_Capture("actual", self.star.image, self.star.number)
            self.pyfocus.ExposedImage(self.camera.LastPictureName)
        
        if self.star.number==2:
            #print "ok"
            image=self.dic[1]
            self.expose_Capture("last", image, 1)
        else : 
            #print "no ok"
            self.star.number
             
    
    def expose_Capture(self, place, image, number):
        label = "label_"+place+"_pic"
        labelinfo=label+"_info"
        getattr(self.ui,label).setPixmap(QtGui.QPixmap.fromImage(image))
        
        if place=="actual" : #update spinBox
            self.ui.doubleSpinBox.setMaximum(number)
            getattr(self.ui,labelinfo).setText(self.tr("try number ")+str(number))
        elif place=="reference" :
            getattr(self.ui,labelinfo).setText(self.tr("reference : ")+str(number))
        elif place=="last":
            getattr(self.ui,labelinfo).setText(self.tr("star nb ")+str(int(number)))
            
            
    
    def do_New_Star_Picture(self):
        self.camera.LastPictureNumber= int(self.camera.LastPictureNumber)+1
        self.camera.LastPictureNumber = str(self.camera.LastPictureNumber)
        dir = self.pyfocusdir+"/picture"
        self.camera.UploadLastPicture(dir)
        image = QtGui.QImage(self.camera.LastPictureName)
        region = image.copy(self.rect)
        self.star.image = region
        self.dic[self.star.number]=self.star.image
    
    def make_reference_from_list(self):
        
        image=self.dic[int(self.ui.doubleSpinBox.value())]
        self.expose_Capture("reference", image, int(self.ui.doubleSpinBox.value()))
        
    
    def make_reference(self):
        """put actual picture as reference"""
        if self.star==None : 
           pass
           # print self.tr("not possible : no star defined")
        else : 
            self.expose_Capture("reference", self.star.image, self.star.number)
        
        
if __name__ == "__main__":

    
    app = QtGui.QApplication(sys.argv)
    
    dir_ = os.path.dirname(__file__)
    #translation
    locale = QtCore.QLocale.system().name()
    #print locale
    #print "pyfocus_" + locale
    qtTranslator = QtCore.QTranslator()
    if qtTranslator.load("qt_" + locale):
        app.installTranslator(qtTranslator)
    appTranslator = QtCore.QTranslator()
    print dir_+"/lang/pyfocus_" + locale
    if appTranslator.load(dir_+"/lang/pyfocus_" + locale):
        app.installTranslator(appTranslator)
        
    windows = StartQT4()
    windows.show()
    sys.exit(app.exec_())
